'use strict';
'use warning';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classPrivateFieldGet2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldGet"));

var _classPrivateFieldSet2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldSet"));

var _indexModuleD = _interopRequireWildcard(require("./../../index.module.d.js"));

var _path = require("path");

var _mysqldump = _interopRequireDefault(require("mysqldump"));

var _lodash = _interopRequireDefault(require("lodash"));

var _moment = _interopRequireDefault(require("moment"));

var _fs = require("fs");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

var _returnedResult = /*#__PURE__*/new WeakMap();

var _mWhere = /*#__PURE__*/new WeakMap();

var _mKey = /*#__PURE__*/new WeakMap();

var _mVal = /*#__PURE__*/new WeakMap();

var _mSearchAdd = /*#__PURE__*/new WeakMap();

var _method = /*#__PURE__*/new WeakMap();

/**
 * Functions Fot Class Mysql Database In Framework
 * All Right Reserved
 * **/

/**
 * @description Ini Adalah Module Library Yang Berisi Konfigurasi Server Untuk Membangun Sebuah Arsitektur Webserver
 * @example
 *     new DKA.Database.MariaDB(options)
 *     .rawQuery()
 * @see https://facebook.com/dhykavangga
 * @description Class Ini Berisi Tentang Membangun Sebuah Fungsi Web Server Di Dalam DKA Framework
 *
 *
 * @class MariaDB
 */
var MariaDB = /*#__PURE__*/function () {
  /**
   * @constructor
   * @param {Number} options.engine
   * @param {string} options.host
   * @param {string} options.user
   * @param {string} options.password
   * @param {string} options.database
   * @param {Boolean} options.isLogging
   * @param {Number} options.port
   * @param {Number} options.timezone
   * @param {number} options.connectionLimit
   * @param {Boolean} options.autoBackup
   * @param {Object} options.encryption
   * @param {boolean} options.encryption.enabled
   * @param {String} options.encryption.engine
   * @param {String} options.encryption.alg
   * @param {Object} options.encryption.options
   */
  function MariaDB(options) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, MariaDB);

    _classPrivateFieldInitSpec(this, _returnedResult, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _mWhere, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _mKey, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _mVal, {
      writable: true,
      value: void 0
    });

    (0, _defineProperty2["default"])(this, "mOptions", void 0);
    (0, _defineProperty2["default"])(this, "DBInstance", void 0);

    _classPrivateFieldInitSpec(this, _mSearchAdd, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _method, {
      writable: true,
      value: void 0
    });

    (0, _defineProperty2["default"])(this, "CreateTable", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(TableName, Rule) {
        var mTableName, arrayColumn, SqlScript;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0, _classPrivateFieldSet2["default"])(_this, _method, MariaDB.MARIADB_METHOD_CREATE_TABLE);
                /** Load Encryption**/

                if (!_this.options.encryption.enabled) {
                  _context.next = 7;
                  break;
                }

                _context.next = 4;
                return _this.EncryptionModule.encodeIvSync(TableName);

              case 4:
                _context.t0 = _context.sent;
                _context.next = 8;
                break;

              case 7:
                _context.t0 = TableName;

              case 8:
                mTableName = _context.t0;
                arrayColumn = [];
                _context.next = 12;
                return Object.keys(Rule).forEach(function (key) {
                  var mKey = _this.options.encryption.options.column && _this.options.encryption.enabled ? _this.EncryptionModule.encodeIvSync("".concat(key)) : key;
                  var typeData = Rule[key].typeData !== undefined ? "".concat(Rule[key].typeData) : _indexModuleD.Options.MARIADB_TYPE_DATA_LONGTEXT;
                  var defaultNotNull = Rule[key].primaryKey !== true ? Rule[key].defaultNotNull !== undefined && Rule[key].defaultNotNull ? "DEFAULT NOT NULL" : "DEFAULT NULL" : "";
                  var autoIncrement = Rule[key].autoIncrement !== undefined && Rule[key].autoIncrement !== false ? _indexModuleD.Options.MARIADB_OPT_AUTO_INCREMENT : "";
                  var primaryKey = Rule[key].primaryKey !== undefined && Rule[key].primaryKey !== false ? _indexModuleD.Options.MARIADB_OPT_AUTO_PRIMARY_KEY : "";
                  var commentColumn = Rule[key].comment !== undefined ? " COMMENT '".concat(Rule[key].comment, "'") : " ";
                  arrayColumn.push(" `".concat(mKey, "` ").concat(typeData, " ").concat(defaultNotNull, " ").concat(autoIncrement).concat(primaryKey).concat(commentColumn));
                });

              case 12:
                SqlScript = "CREATE TABLE`".concat(mTableName, "` (").concat(arrayColumn, ");");
                return _context.abrupt("return", _this.rawQuerySync(SqlScript, []));

              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Create", /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(TableName, Rules) {
        var Rule, mTableName, TypeData, SqlScript, mVal, mKey, mSetData, _SqlScript;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (0, _classPrivateFieldSet2["default"])(_this, _method, MariaDB.MARIADB_METHOD_CREATE);
                Rule = _lodash["default"].extend({
                  data: false
                }, Rules);
                /** Load Encryption**/

                if (!_this.options.encryption.enabled) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 5;
                return _this.EncryptionModule.encodeIvSync(TableName);

              case 5:
                _context2.t0 = _context2.sent;
                _context2.next = 9;
                break;

              case 8:
                _context2.t0 = TableName;

              case 9:
                mTableName = _context2.t0;
                TypeData = Rule.data instanceof Array;

                if (TypeData) {
                  _context2.next = 25;
                  break;
                }

                _this.mKey = [];
                _this.mVal = [];
                Object.keys(Rule.data).forEach(function (key) {
                  _this.mKey.push(" `".concat(_this.options.encryption.enabled && _this.options.encryption.options.column ? _this.EncryptionModule.encodeIvSync("".concat(key)) : key, "` "));

                  _this.mVal.push("\"".concat(_this.options.encryption.enabled && _this.options.encryption.options.column ? _this.EncryptionModule.encodeIvSync("".concat(Rule.data[key])) : Rule.data[key], "\""));
                });
                SqlScript = "INSERT INTO `".concat(mTableName, "` (").concat(_this.mKey, ") VALUES (").concat(_this.mVal, ") ");
                _context2.t1 = _classPrivateFieldSet2["default"];
                _context2.t2 = _this;
                _context2.t3 = _returnedResult;
                _context2.next = 21;
                return _this.rawQuerySync(SqlScript, []);

              case 21:
                _context2.t4 = _context2.sent;
                (0, _context2.t1)(_context2.t2, _context2.t3, _context2.t4);
                _context2.next = 31;
                break;

              case 25:
                mVal = [];
                mKey = [];
                mSetData = [];
                Rule.data.forEach(function (item, index) {
                  mKey = [];
                  mSetData = [];
                  Object.keys(item).forEach(function (key) {
                    mKey.push("".concat(key));
                    mSetData.push("\"".concat(Rule.data[index][key], "\""));
                  });
                  mVal.push("(".concat(mSetData, ")"));
                });
                _SqlScript = "INSERT INTO ".concat(mTableName, " (").concat(mKey, ") VALUES ").concat(mVal, " ");
                return _context2.abrupt("return", _this.rawQuerySync(_SqlScript, []));

              case 31:
                return _context2.abrupt("return", (0, _classPrivateFieldGet2["default"])(_this, _returnedResult));

              case 32:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x3, _x4) {
        return _ref2.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Buat", this.Create);
    (0, _defineProperty2["default"])(this, "Read", /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(TableName) {
        var Rules,
            Rule,
            mTableName,
            TypeData,
            UpdateWhere,
            SelectColumn,
            SelectLimit,
            SelectOrderBy,
            selectParentAs,
            mSQL,
            _args3 = arguments;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                Rules = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
                (0, _classPrivateFieldSet2["default"])(_this, _method, MariaDB.MARIADB_METHOD_READ);
                /** lodash Extend JSON COnfig **/

                Rule = _lodash["default"].extend({
                  as: false,
                  column: [],
                  orderBy: {
                    column: [],
                    mode: "ASC"
                  },
                  search: false,
                  limit: 0
                }, Rules);
                /** Load Encryption**/

                mTableName = "".concat(_this.options.encryption.enabled ? _this.EncryptionModule.encodeIvSync(TableName).toString() : TableName);
                _this.mWhere = [];
                _this.mSearchAdd = "";
                TypeData = Rule.search instanceof Array;

                if (!TypeData) {
                  Object.keys(Rule.search).forEach(function (item) {
                    _this.mSearchAdd += "'".concat(_this.options.encryption.enabled ? _this.EncryptionModule.encodeIvSync(item).toString() : item, "' = '").concat(_this.options.encryption.enabled ? _this.EncryptionModule.encodeIvSync(Rule.search[item]) : Rule.search[item], "' ");
                  });
                } else {
                  Rule.search.forEach(function (item) {
                    if (item instanceof Object) {
                      Object.keys(item).forEach(function (k) {
                        _this.mSearchAdd += "`".concat(k, "`='").concat(item[k], "' ");
                      });
                    } else {
                      _this.mSearchAdd += item;
                    }
                  });
                }

                UpdateWhere = Rule.search !== false ? "WHERE ".concat(_this.mSearchAdd) : "";
                SelectColumn = Rule.column.length > 0 ? Rule.column : "*";
                SelectLimit = Rule.limit > 0 ? "LIMIT ".concat(Rule.limit) : "";
                SelectOrderBy = Rule.orderBy.column.length > 0 ? "ORDER BY ".concat(Rule.orderBy.column, " ").concat(Rule.orderBy.mode) : "";
                selectParentAs = Rule.as !== false ? "as `".concat(Rule.a, "`") : "";
                mSQL = "SELECT ".concat(SelectColumn, " FROM `").concat(mTableName, "`").concat(selectParentAs, " ").concat(UpdateWhere, " \n ").concat(SelectOrderBy, " ").concat(SelectLimit);
                return _context3.abrupt("return", _this.rawQuerySync(mSQL, []));

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      return function (_x5) {
        return _ref3.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Baca", this.Read);
    (0, _defineProperty2["default"])(this, "Update", /*#__PURE__*/function () {
      var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(TableName, Rules) {
        var Rule, UpdateWhere, mSQL;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                (0, _classPrivateFieldSet2["default"])(_this, _method, MariaDB.MARIADB_METHOD_UPDATE);
                /** Merge JSON Extend loDash **/

                Rule = _lodash["default"].extend({
                  data: false,
                  search: false
                }, Rules);
                _this.mKey = [];
                _this.mWhere = [];
                Object.keys(Rule.data).forEach(function (key) {
                  _this.mKey.push(" ".concat(key, " = '").concat(Rule.data[key], "'"));
                });
                Object.keys(Rule.search).forEach(function (key) {
                  _this.mWhere.push("".concat(key, " = '").concat(Rule.search[key], "'"));
                });
                UpdateWhere = Rule.search !== false ? "WHERE ".concat(_this.mWhere) : "";
                mSQL = "UPDATE `".concat(TableName, "` SET").concat(_this.mKey, " ").concat(UpdateWhere, " ");
                return _context4.abrupt("return", _this.rawQuerySync(mSQL, []));

              case 9:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function (_x6, _x7) {
        return _ref4.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Ubah", this.Update);
    (0, _defineProperty2["default"])(this, "Delete", /*#__PURE__*/function () {
      var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(TableName, Rules) {
        var Rule, DeleteWhere, SqlScript;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                (0, _classPrivateFieldSet2["default"])(_this, _method, MariaDB.MARIADB_METHOD_DELETE);
                Rule = _lodash["default"].extend({
                  search: false
                }, Rules);
                _this.mWhere = [];
                Object.keys(Rule.search).forEach(function (key) {
                  _this.mWhere.push(" `".concat(key, "` = \"").concat(Rule.search[key], "\" "));
                });
                DeleteWhere = Rule.search !== false ? "WHERE ".concat(_this.mWhere) : "";
                SqlScript = "DELETE FROM `".concat(TableName, "` ").concat(DeleteWhere, " ");
                return _context5.abrupt("return", _this.rawQuerySync(SqlScript, []));

              case 7:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      return function (_x8, _x9) {
        return _ref5.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Hapus", this.Delete);
    (0, _defineProperty2["default"])(this, "Export", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
      var backupPath, mDate, filename;
      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              backupPath = _indexModuleD.Server.CONFIG === undefined ? (0, _path.join)(require.main.filename, "./../Backup") : _indexModuleD.Server.CONFIG.options.backupDir;
              mDate = new Date();
              filename = (0, _path.join)(backupPath, "./".concat(_this.options.host, ".").concat(_this.options.database, ".").concat(mDate.getDate(), "-").concat(mDate.getMonth(), "-").concat(mDate.getFullYear(), ".sql.gz"));
              _context7.next = 5;
              return new Promise( /*#__PURE__*/function () {
                var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(resolve, rejected) {
                  return _regenerator["default"].wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          if (!(0, _fs.existsSync)(backupPath)) {
                            _context6.next = 16;
                            break;
                          }

                          _context6.prev = 1;

                          if ((0, _fs.existsSync)(filename)) {
                            _context6.next = 8;
                            break;
                          }

                          _context6.next = 5;
                          return (0, _mysqldump["default"])({
                            connection: {
                              host: _this.options.host,
                              user: _this.options.user,
                              password: _this.options.password,
                              database: _this.options.database
                            },
                            dumpToFile: filename
                          });

                        case 5:
                          resolve({
                            status: true,
                            code: 200,
                            msg: "Backup SQL Is Successfully in ".concat(backupPath, " ")
                          });
                          _context6.next = 9;
                          break;

                        case 8:
                          resolve({
                            status: true,
                            code: 200,
                            msg: "File Backup is Exist. Skip Save Database"
                          });

                        case 9:
                          _context6.next = 14;
                          break;

                        case 11:
                          _context6.prev = 11;
                          _context6.t0 = _context6["catch"](1);
                          rejected({
                            status: false,
                            code: 501,
                            msg: "Error Detected",
                            error: _context6.t0
                          });

                        case 14:
                          _context6.next = 17;
                          break;

                        case 16:
                          rejected({
                            status: false,
                            code: 500,
                            msg: "Error Detected",
                            error: "Folder Backup Not Detected in \"".concat(backupPath, "\". Please Create Folder Backup First")
                          });
                          /*mkdirSync(backupPath, {
                              mode : '0777'
                          })*/

                        case 17:
                        case "end":
                          return _context6.stop();
                      }
                    }
                  }, _callee6, null, [[1, 11]]);
                }));

                return function (_x10, _x11) {
                  return _ref7.apply(this, arguments);
                };
              }());

            case 5:
              return _context7.abrupt("return", _context7.sent);

            case 6:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    })));
    (0, _defineProperty2["default"])(this, "rawQuerySync", /*#__PURE__*/function () {
      var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21(SQLString, ArrayParams) {
        var mSQLString, timeStart;
        return _regenerator["default"].wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                mSQLString = SQLString;
                timeStart = new Date().getTime();
                /** Promise To Task Future **/

                return _context21.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20(resolve, rejected) {
                    return _regenerator["default"].wrap(function _callee20$(_context20) {
                      while (1) {
                        switch (_context20.prev = _context20.next) {
                          case 0:
                            _context20.t0 = _this.options.engine;
                            _context20.next = _context20.t0 === MariaDB.MARIADB_POOL ? 3 : _context20.t0 === MariaDB.MARIADB_POOL_CLUSTER ? 5 : 7;
                            break;

                          case 3:
                            _this.DBInstance.getConnection().then( /*#__PURE__*/function () {
                              var _ref10 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(conn) {
                                return _regenerator["default"].wrap(function _callee10$(_context10) {
                                  while (1) {
                                    switch (_context10.prev = _context10.next) {
                                      case 0:
                                        _context10.next = 2;
                                        return conn.query(mSQLString, ArrayParams).then( /*#__PURE__*/function () {
                                          var _ref11 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(rows) {
                                            var timeEnd, metadata, dataArray;
                                            return _regenerator["default"].wrap(function _callee8$(_context8) {
                                              while (1) {
                                                switch (_context8.prev = _context8.next) {
                                                  case 0:
                                                    timeEnd = new Date().getTime();
                                                    metadata = {
                                                      activeConnections: _this.DBInstance.activeConnections(),
                                                      idleConnections: _this.DBInstance.idleConnections(),
                                                      totalConnections: _this.DBInstance.totalConnections(),
                                                      sqlRaw: SQLString,
                                                      timeExecuteinSecond: "".concat(timeEnd - timeStart, " ms")
                                                    };
                                                    _context8.t0 = (0, _classPrivateFieldGet2["default"])(_this, _method);
                                                    _context8.next = _context8.t0 === MariaDB.MARIADB_METHOD_CREATE_TABLE ? 5 : _context8.t0 === MariaDB.MARIADB_METHOD_CREATE ? 17 : _context8.t0 === MariaDB.MARIADB_METHOD_READ ? 36 : _context8.t0 === MariaDB.MARIADB_METHOD_UPDATE ? 58 : _context8.t0 === MariaDB.MARIADB_METHOD_DELETE ? 77 : 96;
                                                    break;

                                                  case 5:
                                                    _context8.next = 7;
                                                    return rows.warningStatus < 1;

                                                  case 7:
                                                    if (!_context8.sent) {
                                                      _context8.next = 12;
                                                      break;
                                                    }

                                                    _context8.next = 10;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been created",
                                                      metadata: metadata
                                                    });

                                                  case 10:
                                                    _context8.next = 14;
                                                    break;

                                                  case 12:
                                                    _context8.next = 14;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      metadata: metadata
                                                    });

                                                  case 14:
                                                    _context8.next = 16;
                                                    return conn.release();

                                                  case 16:
                                                    return _context8.abrupt("break", 108);

                                                  case 17:
                                                    _context8.next = 19;
                                                    return rows.affectedRows > 0;

                                                  case 19:
                                                    if (!_context8.sent) {
                                                      _context8.next = 31;
                                                      break;
                                                    }

                                                    _context8.next = 22;
                                                    return rows.warningStatus < 1;

                                                  case 22:
                                                    if (!_context8.sent) {
                                                      _context8.next = 27;
                                                      break;
                                                    }

                                                    _context8.next = 25;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been created",
                                                      id: rows.insertId,
                                                      metadata: metadata
                                                    });

                                                  case 25:
                                                    _context8.next = 29;
                                                    break;

                                                  case 27:
                                                    _context8.next = 29;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      id: rows.insertId,
                                                      metadata: metadata
                                                    });

                                                  case 29:
                                                    _context8.next = 33;
                                                    break;

                                                  case 31:
                                                    _context8.next = 33;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 33:
                                                    _context8.next = 35;
                                                    return conn.release();

                                                  case 35:
                                                    return _context8.abrupt("break", 108);

                                                  case 36:
                                                    if (!(rows.length > 0)) {
                                                      _context8.next = 53;
                                                      break;
                                                    }

                                                    if (!(_this.options.encryption.enabled && _this.options.encryption.options.column)) {
                                                      _context8.next = 47;
                                                      break;
                                                    }

                                                    dataArray = [];
                                                    _context8.next = 41;
                                                    return rows.forEach(function (res) {
                                                      var dataJSON = {};
                                                      Object.keys(res).forEach(function (key) {
                                                        dataJSON[_this.EncryptionModule.decodeIvSync(key)] = _this.EncryptionModule.decodeIvSync(res[key]);
                                                      });
                                                      dataArray.push(dataJSON);
                                                    });

                                                  case 41:
                                                    _context8.next = 43;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been read",
                                                      data: dataArray,
                                                      metadata: metadata
                                                    });

                                                  case 43:
                                                    _context8.next = 45;
                                                    return conn.release();

                                                  case 45:
                                                    _context8.next = 51;
                                                    break;

                                                  case 47:
                                                    _context8.next = 49;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been read",
                                                      data: rows,
                                                      metadata: metadata
                                                    });

                                                  case 49:
                                                    _context8.next = 51;
                                                    return conn.release();

                                                  case 51:
                                                    _context8.next = 57;
                                                    break;

                                                  case 53:
                                                    _context8.next = 55;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Found",
                                                      metadata: metadata
                                                    });

                                                  case 55:
                                                    _context8.next = 57;
                                                    return conn.release();

                                                  case 57:
                                                    return _context8.abrupt("break", 108);

                                                  case 58:
                                                    _context8.next = 60;
                                                    return rows.affectedRows > 0;

                                                  case 60:
                                                    if (!_context8.sent) {
                                                      _context8.next = 72;
                                                      break;
                                                    }

                                                    _context8.next = 63;
                                                    return rows.warningStatus < 1;

                                                  case 63:
                                                    if (!_context8.sent) {
                                                      _context8.next = 68;
                                                      break;
                                                    }

                                                    _context8.next = 66;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been update",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 66:
                                                    _context8.next = 70;
                                                    break;

                                                  case 68:
                                                    _context8.next = 70;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 70:
                                                    _context8.next = 74;
                                                    break;

                                                  case 72:
                                                    _context8.next = 74;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 74:
                                                    _context8.next = 76;
                                                    return conn.release();

                                                  case 76:
                                                    return _context8.abrupt("break", 108);

                                                  case 77:
                                                    _context8.next = 79;
                                                    return rows.affectedRows > 0;

                                                  case 79:
                                                    if (!_context8.sent) {
                                                      _context8.next = 91;
                                                      break;
                                                    }

                                                    _context8.next = 82;
                                                    return rows.warningStatus < 1;

                                                  case 82:
                                                    if (!_context8.sent) {
                                                      _context8.next = 87;
                                                      break;
                                                    }

                                                    _context8.next = 85;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been deleted",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 85:
                                                    _context8.next = 89;
                                                    break;

                                                  case 87:
                                                    _context8.next = 89;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 89:
                                                    _context8.next = 93;
                                                    break;

                                                  case 91:
                                                    _context8.next = 93;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 93:
                                                    _context8.next = 95;
                                                    return conn.release();

                                                  case 95:
                                                    return _context8.abrupt("break", 108);

                                                  case 96:
                                                    _context8.next = 98;
                                                    return rows.length > 0;

                                                  case 98:
                                                    if (!_context8.sent) {
                                                      _context8.next = 103;
                                                      break;
                                                    }

                                                    _context8.next = 101;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been execute",
                                                      data: rows,
                                                      metadata: metadata
                                                    });

                                                  case 101:
                                                    _context8.next = 105;
                                                    break;

                                                  case 103:
                                                    _context8.next = 105;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Found",
                                                      metadata: metadata
                                                    });

                                                  case 105:
                                                    _context8.next = 107;
                                                    return conn.release();

                                                  case 107:
                                                    return _context8.abrupt("break", 108);

                                                  case 108:
                                                  case "end":
                                                    return _context8.stop();
                                                }
                                              }
                                            }, _callee8);
                                          }));

                                          return function (_x17) {
                                            return _ref11.apply(this, arguments);
                                          };
                                        }())["catch"]( /*#__PURE__*/function () {
                                          var _ref12 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(err) {
                                            return _regenerator["default"].wrap(function _callee9$(_context9) {
                                              while (1) {
                                                switch (_context9.prev = _context9.next) {
                                                  case 0:
                                                    _context9.t0 = err.code;
                                                    _context9.next = _context9.t0 === 'ER_TABLE_EXISTS_ERROR' ? 3 : 8;
                                                    break;

                                                  case 3:
                                                    _context9.next = 5;
                                                    return rejected({
                                                      status: false,
                                                      code: 500,
                                                      msg: "Failed, Table Name Is Exists",
                                                      error: {
                                                        errorMsg: err.text,
                                                        errorCode: err.code,
                                                        errNo: err.errno
                                                      }
                                                    });

                                                  case 5:
                                                    _context9.next = 7;
                                                    return conn.release();

                                                  case 7:
                                                    return _context9.abrupt("break", 12);

                                                  case 8:
                                                    _context9.next = 10;
                                                    return rejected({
                                                      status: false,
                                                      code: 500,
                                                      msg: "Error Detected",
                                                      error: {
                                                        errorMsg: err.text,
                                                        errorCode: err.code,
                                                        errNo: err.errno
                                                      }
                                                    });

                                                  case 10:
                                                    _context9.next = 12;
                                                    return conn.release();

                                                  case 12:
                                                  case "end":
                                                    return _context9.stop();
                                                }
                                              }
                                            }, _callee9);
                                          }));

                                          return function (_x18) {
                                            return _ref12.apply(this, arguments);
                                          };
                                        }());

                                      case 2:
                                      case "end":
                                        return _context10.stop();
                                    }
                                  }
                                }, _callee10);
                              }));

                              return function (_x16) {
                                return _ref10.apply(this, arguments);
                              };
                            }())["catch"]( /*#__PURE__*/function () {
                              var _ref13 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(error) {
                                return _regenerator["default"].wrap(function _callee11$(_context11) {
                                  while (1) {
                                    switch (_context11.prev = _context11.next) {
                                      case 0:
                                        _context11.t0 = error.code;
                                        _context11.next = _context11.t0 === 'ER_BAD_DB_ERROR' ? 3 : _context11.t0 === 'ER_GET_CONNECTION_TIMEOUT' ? 6 : 9;
                                        break;

                                      case 3:
                                        _context11.next = 5;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "database name is not resolved. check database name in constructor configuration",
                                          error: {
                                            fatal: error.fatal,
                                            text: error.text,
                                            sqlState: error.sqlState,
                                            code: error.code
                                          }
                                        });

                                      case 5:
                                        return _context11.abrupt("break", 11);

                                      case 6:
                                        _context11.next = 8;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "connection to database server timed out",
                                          error: {
                                            fatal: error.fatal,
                                            text: error.text,
                                            sqlState: error.sqlState,
                                            code: error.code
                                          }
                                        });

                                      case 8:
                                        return _context11.abrupt("break", 11);

                                      case 9:
                                        _context11.next = 11;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "An unknown error occurred",
                                          error: error
                                        });

                                      case 11:
                                      case "end":
                                        return _context11.stop();
                                    }
                                  }
                                }, _callee11);
                              }));

                              return function (_x19) {
                                return _ref13.apply(this, arguments);
                              };
                            }());

                            return _context20.abrupt("break", 9);

                          case 5:
                            _this.DBInstance.getConnection().then( /*#__PURE__*/function () {
                              var _ref14 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14(conn) {
                                return _regenerator["default"].wrap(function _callee14$(_context14) {
                                  while (1) {
                                    switch (_context14.prev = _context14.next) {
                                      case 0:
                                        _context14.next = 2;
                                        return conn.query(mSQLString, ArrayParams).then( /*#__PURE__*/function () {
                                          var _ref15 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(rows) {
                                            var metadata;
                                            return _regenerator["default"].wrap(function _callee12$(_context12) {
                                              while (1) {
                                                switch (_context12.prev = _context12.next) {
                                                  case 0:
                                                    metadata = {
                                                      activeConnections: _this.DBInstance.activeConnections(),
                                                      idleConnections: _this.DBInstance.idleConnections(),
                                                      totalConnections: _this.DBInstance.totalConnections()
                                                    };
                                                    _context12.t0 = (0, _classPrivateFieldGet2["default"])(_this, _method);
                                                    _context12.next = _context12.t0 === MariaDB.MARIADB_METHOD_CREATE ? 4 : _context12.t0 === MariaDB.MARIADB_METHOD_READ ? 23 : _context12.t0 === MariaDB.MARIADB_METHOD_UPDATE ? 35 : _context12.t0 === MariaDB.MARIADB_METHOD_DELETE ? 54 : 73;
                                                    break;

                                                  case 4:
                                                    _context12.next = 6;
                                                    return rows.affectedRows > 0;

                                                  case 6:
                                                    if (!_context12.sent) {
                                                      _context12.next = 18;
                                                      break;
                                                    }

                                                    _context12.next = 9;
                                                    return rows.warningStatus < 1;

                                                  case 9:
                                                    if (!_context12.sent) {
                                                      _context12.next = 14;
                                                      break;
                                                    }

                                                    _context12.next = 12;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been created",
                                                      id: rows.insertId,
                                                      metadata: metadata
                                                    });

                                                  case 12:
                                                    _context12.next = 16;
                                                    break;

                                                  case 14:
                                                    _context12.next = 16;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      id: rows.insertId,
                                                      metadata: metadata
                                                    });

                                                  case 16:
                                                    _context12.next = 20;
                                                    break;

                                                  case 18:
                                                    _context12.next = 20;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 20:
                                                    _context12.next = 22;
                                                    return conn.release();

                                                  case 22:
                                                    return _context12.abrupt("break", 85);

                                                  case 23:
                                                    _context12.next = 25;
                                                    return rows.length > 0;

                                                  case 25:
                                                    if (!_context12.sent) {
                                                      _context12.next = 30;
                                                      break;
                                                    }

                                                    _context12.next = 28;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been read",
                                                      data: rows,
                                                      metadata: metadata
                                                    });

                                                  case 28:
                                                    _context12.next = 32;
                                                    break;

                                                  case 30:
                                                    _context12.next = 32;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Found",
                                                      metadata: metadata
                                                    });

                                                  case 32:
                                                    _context12.next = 34;
                                                    return conn.release();

                                                  case 34:
                                                    return _context12.abrupt("break", 85);

                                                  case 35:
                                                    _context12.next = 37;
                                                    return rows.affectedRows > 0;

                                                  case 37:
                                                    if (!_context12.sent) {
                                                      _context12.next = 49;
                                                      break;
                                                    }

                                                    _context12.next = 40;
                                                    return rows.warningStatus < 1;

                                                  case 40:
                                                    if (!_context12.sent) {
                                                      _context12.next = 45;
                                                      break;
                                                    }

                                                    _context12.next = 43;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been update",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 43:
                                                    _context12.next = 47;
                                                    break;

                                                  case 45:
                                                    _context12.next = 47;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 47:
                                                    _context12.next = 51;
                                                    break;

                                                  case 49:
                                                    _context12.next = 51;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 51:
                                                    _context12.next = 53;
                                                    return conn.release();

                                                  case 53:
                                                    return _context12.abrupt("break", 85);

                                                  case 54:
                                                    _context12.next = 56;
                                                    return rows.affectedRows > 0;

                                                  case 56:
                                                    if (!_context12.sent) {
                                                      _context12.next = 68;
                                                      break;
                                                    }

                                                    _context12.next = 59;
                                                    return rows.warningStatus < 1;

                                                  case 59:
                                                    if (!_context12.sent) {
                                                      _context12.next = 64;
                                                      break;
                                                    }

                                                    _context12.next = 62;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been deleted",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 62:
                                                    _context12.next = 66;
                                                    break;

                                                  case 64:
                                                    _context12.next = 66;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 66:
                                                    _context12.next = 70;
                                                    break;

                                                  case 68:
                                                    _context12.next = 70;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 70:
                                                    _context12.next = 72;
                                                    return conn.release();

                                                  case 72:
                                                    return _context12.abrupt("break", 85);

                                                  case 73:
                                                    _context12.next = 75;
                                                    return rows.length > 0;

                                                  case 75:
                                                    if (!_context12.sent) {
                                                      _context12.next = 80;
                                                      break;
                                                    }

                                                    _context12.next = 78;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been execute",
                                                      data: rows,
                                                      metadata: metadata
                                                    });

                                                  case 78:
                                                    _context12.next = 82;
                                                    break;

                                                  case 80:
                                                    _context12.next = 82;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Found",
                                                      metadata: metadata
                                                    });

                                                  case 82:
                                                    _context12.next = 84;
                                                    return conn.release();

                                                  case 84:
                                                    return _context12.abrupt("break", 85);

                                                  case 85:
                                                  case "end":
                                                    return _context12.stop();
                                                }
                                              }
                                            }, _callee12);
                                          }));

                                          return function (_x21) {
                                            return _ref15.apply(this, arguments);
                                          };
                                        }())["catch"]( /*#__PURE__*/function () {
                                          var _ref16 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(err) {
                                            return _regenerator["default"].wrap(function _callee13$(_context13) {
                                              while (1) {
                                                switch (_context13.prev = _context13.next) {
                                                  case 0:
                                                    _context13.next = 2;
                                                    return rejected({
                                                      status: false,
                                                      code: 500,
                                                      msg: "Error Detected",
                                                      error: {
                                                        errorMsg: err.text,
                                                        errorCode: err.code,
                                                        errNo: err.errno
                                                      }
                                                    });

                                                  case 2:
                                                    _context13.next = 4;
                                                    return conn.release();

                                                  case 4:
                                                  case "end":
                                                    return _context13.stop();
                                                }
                                              }
                                            }, _callee13);
                                          }));

                                          return function (_x22) {
                                            return _ref16.apply(this, arguments);
                                          };
                                        }());

                                      case 2:
                                      case "end":
                                        return _context14.stop();
                                    }
                                  }
                                }, _callee14);
                              }));

                              return function (_x20) {
                                return _ref14.apply(this, arguments);
                              };
                            }())["catch"]( /*#__PURE__*/function () {
                              var _ref17 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(error) {
                                return _regenerator["default"].wrap(function _callee15$(_context15) {
                                  while (1) {
                                    switch (_context15.prev = _context15.next) {
                                      case 0:
                                        _context15.t0 = error.code;
                                        _context15.next = _context15.t0 === 'ER_BAD_DB_ERROR' ? 3 : _context15.t0 === 'ER_GET_CONNECTION_TIMEOUT' ? 6 : 9;
                                        break;

                                      case 3:
                                        _context15.next = 5;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "database name is not resolved. check database name in constructor configuration",
                                          error: {
                                            fatal: error.fatal,
                                            text: error.text,
                                            sqlState: error.sqlState,
                                            code: error.code
                                          }
                                        });

                                      case 5:
                                        return _context15.abrupt("break", 11);

                                      case 6:
                                        _context15.next = 8;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "connection to database server timed out",
                                          error: {
                                            fatal: error.fatal,
                                            text: error.text,
                                            sqlState: error.sqlState,
                                            code: error.code
                                          }
                                        });

                                      case 8:
                                        return _context15.abrupt("break", 11);

                                      case 9:
                                        _context15.next = 11;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "An unknown error occurred",
                                          error: error
                                        });

                                      case 11:
                                      case "end":
                                        return _context15.stop();
                                    }
                                  }
                                }, _callee15);
                              }));

                              return function (_x23) {
                                return _ref17.apply(this, arguments);
                              };
                            }());

                            return _context20.abrupt("break", 9);

                          case 7:
                            _this.DBInstance.then( /*#__PURE__*/function () {
                              var _ref18 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18(conn) {
                                return _regenerator["default"].wrap(function _callee18$(_context18) {
                                  while (1) {
                                    switch (_context18.prev = _context18.next) {
                                      case 0:
                                        _context18.next = 2;
                                        return conn.query(mSQLString, ArrayParams).then( /*#__PURE__*/function () {
                                          var _ref19 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(rows) {
                                            var metadata;
                                            return _regenerator["default"].wrap(function _callee16$(_context16) {
                                              while (1) {
                                                switch (_context16.prev = _context16.next) {
                                                  case 0:
                                                    metadata = {};
                                                    _context16.t0 = (0, _classPrivateFieldGet2["default"])(_this, _method);
                                                    _context16.next = _context16.t0 === MariaDB.MARIADB_METHOD_CREATE ? 4 : _context16.t0 === MariaDB.MARIADB_METHOD_READ ? 23 : _context16.t0 === MariaDB.MARIADB_METHOD_UPDATE ? 35 : _context16.t0 === MariaDB.MARIADB_METHOD_DELETE ? 54 : 73;
                                                    break;

                                                  case 4:
                                                    _context16.next = 6;
                                                    return rows.affectedRows > 0;

                                                  case 6:
                                                    if (!_context16.sent) {
                                                      _context16.next = 18;
                                                      break;
                                                    }

                                                    _context16.next = 9;
                                                    return rows.warningStatus < 1;

                                                  case 9:
                                                    if (!_context16.sent) {
                                                      _context16.next = 14;
                                                      break;
                                                    }

                                                    _context16.next = 12;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been created",
                                                      id: rows.insertId,
                                                      metadata: metadata
                                                    });

                                                  case 12:
                                                    _context16.next = 16;
                                                    break;

                                                  case 14:
                                                    _context16.next = 16;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      id: rows.insertId,
                                                      metadata: metadata
                                                    });

                                                  case 16:
                                                    _context16.next = 20;
                                                    break;

                                                  case 18:
                                                    _context16.next = 20;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 20:
                                                    _context16.next = 22;
                                                    return conn.end();

                                                  case 22:
                                                    return _context16.abrupt("break", 85);

                                                  case 23:
                                                    _context16.next = 25;
                                                    return rows.length > 0;

                                                  case 25:
                                                    if (!_context16.sent) {
                                                      _context16.next = 30;
                                                      break;
                                                    }

                                                    _context16.next = 28;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been read",
                                                      data: rows,
                                                      metadata: metadata
                                                    });

                                                  case 28:
                                                    _context16.next = 32;
                                                    break;

                                                  case 30:
                                                    _context16.next = 32;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Found",
                                                      metadata: metadata
                                                    });

                                                  case 32:
                                                    _context16.next = 34;
                                                    return conn.end();

                                                  case 34:
                                                    return _context16.abrupt("break", 85);

                                                  case 35:
                                                    _context16.next = 37;
                                                    return rows.affectedRows > 0;

                                                  case 37:
                                                    if (!_context16.sent) {
                                                      _context16.next = 49;
                                                      break;
                                                    }

                                                    _context16.next = 40;
                                                    return rows.warningStatus < 1;

                                                  case 40:
                                                    if (!_context16.sent) {
                                                      _context16.next = 45;
                                                      break;
                                                    }

                                                    _context16.next = 43;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been update",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 43:
                                                    _context16.next = 47;
                                                    break;

                                                  case 45:
                                                    _context16.next = 47;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 47:
                                                    _context16.next = 51;
                                                    break;

                                                  case 49:
                                                    _context16.next = 51;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 51:
                                                    _context16.next = 53;
                                                    return conn.end();

                                                  case 53:
                                                    return _context16.abrupt("break", 85);

                                                  case 54:
                                                    _context16.next = 56;
                                                    return rows.affectedRows > 0;

                                                  case 56:
                                                    if (!_context16.sent) {
                                                      _context16.next = 68;
                                                      break;
                                                    }

                                                    _context16.next = 59;
                                                    return rows.warningStatus < 1;

                                                  case 59:
                                                    if (!_context16.sent) {
                                                      _context16.next = 64;
                                                      break;
                                                    }

                                                    _context16.next = 62;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been deleted",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 62:
                                                    _context16.next = 66;
                                                    break;

                                                  case 64:
                                                    _context16.next = 66;
                                                    return rejected({
                                                      status: false,
                                                      code: 201,
                                                      msg: "warning status detected. Check Warning Message",
                                                      rows: rows.affectedRows,
                                                      metadata: metadata
                                                    });

                                                  case 66:
                                                    _context16.next = 70;
                                                    break;

                                                  case 68:
                                                    _context16.next = 70;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Changed",
                                                      metadata: metadata
                                                    });

                                                  case 70:
                                                    _context16.next = 72;
                                                    return conn.end();

                                                  case 72:
                                                    return _context16.abrupt("break", 85);

                                                  case 73:
                                                    _context16.next = 75;
                                                    return rows.length > 0;

                                                  case 75:
                                                    if (!_context16.sent) {
                                                      _context16.next = 80;
                                                      break;
                                                    }

                                                    _context16.next = 78;
                                                    return resolve({
                                                      status: true,
                                                      code: 200,
                                                      msg: "successful, your data has been execute",
                                                      data: rows,
                                                      metadata: metadata
                                                    });

                                                  case 78:
                                                    _context16.next = 82;
                                                    break;

                                                  case 80:
                                                    _context16.next = 82;
                                                    return rejected({
                                                      status: false,
                                                      code: 404,
                                                      msg: "Succeeded, But No Data Found",
                                                      metadata: metadata
                                                    });

                                                  case 82:
                                                    _context16.next = 84;
                                                    return conn.end();

                                                  case 84:
                                                    return _context16.abrupt("break", 85);

                                                  case 85:
                                                  case "end":
                                                    return _context16.stop();
                                                }
                                              }
                                            }, _callee16);
                                          }));

                                          return function (_x25) {
                                            return _ref19.apply(this, arguments);
                                          };
                                        }())["catch"]( /*#__PURE__*/function () {
                                          var _ref20 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17(err) {
                                            return _regenerator["default"].wrap(function _callee17$(_context17) {
                                              while (1) {
                                                switch (_context17.prev = _context17.next) {
                                                  case 0:
                                                    _context17.next = 2;
                                                    return rejected({
                                                      status: false,
                                                      code: 500,
                                                      msg: "Error Detected",
                                                      error: {
                                                        errorMsg: err.text,
                                                        errorCode: err.code,
                                                        errNo: err.errno
                                                      }
                                                    });

                                                  case 2:
                                                    _context17.next = 4;
                                                    return conn.end();

                                                  case 4:
                                                  case "end":
                                                    return _context17.stop();
                                                }
                                              }
                                            }, _callee17);
                                          }));

                                          return function (_x26) {
                                            return _ref20.apply(this, arguments);
                                          };
                                        }());

                                      case 2:
                                      case "end":
                                        return _context18.stop();
                                    }
                                  }
                                }, _callee18);
                              }));

                              return function (_x24) {
                                return _ref18.apply(this, arguments);
                              };
                            }())["catch"]( /*#__PURE__*/function () {
                              var _ref21 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19(error) {
                                return _regenerator["default"].wrap(function _callee19$(_context19) {
                                  while (1) {
                                    switch (_context19.prev = _context19.next) {
                                      case 0:
                                        _context19.t0 = error.code;
                                        _context19.next = _context19.t0 === 'ER_BAD_DB_ERROR' ? 3 : _context19.t0 === 'ER_GET_CONNECTION_TIMEOUT' ? 6 : 9;
                                        break;

                                      case 3:
                                        _context19.next = 5;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "database name is not resolved. check database name in constructor configuration",
                                          error: {
                                            fatal: error.fatal,
                                            text: error.text,
                                            sqlState: error.sqlState,
                                            code: error.code
                                          }
                                        });

                                      case 5:
                                        return _context19.abrupt("break", 11);

                                      case 6:
                                        _context19.next = 8;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "connection to database server timed out",
                                          error: {
                                            fatal: error.fatal,
                                            text: error.text,
                                            sqlState: error.sqlState,
                                            code: error.code
                                          }
                                        });

                                      case 8:
                                        return _context19.abrupt("break", 11);

                                      case 9:
                                        _context19.next = 11;
                                        return rejected({
                                          status: false,
                                          code: 505,
                                          msg: "An unknown error occurred",
                                          error: error
                                        });

                                      case 11:
                                      case "end":
                                        return _context19.stop();
                                    }
                                  }
                                }, _callee19);
                              }));

                              return function (_x27) {
                                return _ref21.apply(this, arguments);
                              };
                            }());

                            return _context20.abrupt("break", 9);

                          case 9:
                          case "end":
                            return _context20.stop();
                        }
                      }
                    }, _callee20);
                  }));

                  return function (_x14, _x15) {
                    return _ref9.apply(this, arguments);
                  };
                }()));

              case 3:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee21);
      }));

      return function (_x12, _x13) {
        return _ref8.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Sql", this.rawQuerySync);
    this.options = _lodash["default"].merge(_indexModuleD["default"].config.Database.MariaDB, options);
    _indexModuleD["default"].config.Database.MariaDB = this.options;
    /** **
     *
     * */

    var MariaDBEngine = require("mariadb");

    _moment["default"].locale("id");

    switch (this.options.encryption.engine) {
      case _indexModuleD.Options.ENCRYPTION_ENGINE_CRYPTO:
        this.EncryptionModule = new _indexModuleD.Security.Encryption.Crypto({
          alg: _indexModuleD.Options.ALGORITHM_AES_256_GCM,
          secretKey: this.options.encryption.secretKey
        });
        break;

      default:
        this.EncryptionModule = new _indexModuleD.Security.Encryption.Crypto();
    }

    switch (this.options.engine) {
      case MariaDB.MARIADB_POOL:
        this.DBInstance = MariaDBEngine.createPool(this.options);
        break;

      case MariaDB.MARIADB_POOL_CLUSTER:
        this.DBInstance = MariaDBEngine.createPoolCluster(this.options);
        break;

      case MariaDB.MARIADB_CREATECONNECTION:
        this.DBInstance = MariaDBEngine.createConnection(this.options);
        break;

      default:
        this.DBInstance = MariaDBEngine.createPool(this.options);
        break;
    }
  }
  /**
   * @constructor
   * @param {String} TableName
   * @param {[]} Rule Place Your Model Data
   * @param {String} Rule.typeData Place Your Model Data
   * @param {Boolean} Rule.defaultNotNull Place Your Model Data
   * @param {Boolean} Rule.ifNotExist Create Table If Not Exists
   * @returns {Promise<unknown> | JSON}
   * @description
   */


  (0, _createClass2["default"])(MariaDB, [{
    key: "rawQuery",
    value:
    /**
     * @description this Function Package Is The raw SQL Script To Connect MariaDB
     * @constructor
     * @deprecated move to rawQuerySync
     * @param {String} SQLString - The SQL Script
     * @param {Array} ArrayParams - Array For Inject Data
     * @param {Function} Callback - Function With (error, result, fields)
     */
    function rawQuery(SQLString, ArrayParams, Callback) {
      /** Declaration Of Variable **/
      switch (this.options.engine) {
        case MariaDB.MARIADB_POOL:
          /** Module Get Connection For The Library **/
          this.DBInstance.getConnection().then( /*#__PURE__*/function () {
            var _ref22 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee25(conn) {
              return _regenerator["default"].wrap(function _callee25$(_context25) {
                while (1) {
                  switch (_context25.prev = _context25.next) {
                    case 0:
                      _context25.next = 2;
                      return conn.query(SQLString, ArrayParams).then( /*#__PURE__*/function () {
                        var _ref23 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee22(rows, res) {
                          return _regenerator["default"].wrap(function _callee22$(_context22) {
                            while (1) {
                              switch (_context22.prev = _context22.next) {
                                case 0:
                                  _context22.next = 2;
                                  return Callback(null, rows, res);

                                case 2:
                                  return _context22.abrupt("return", true);

                                case 3:
                                case "end":
                                  return _context22.stop();
                              }
                            }
                          }, _callee22);
                        }));

                        return function (_x29, _x30) {
                          return _ref23.apply(this, arguments);
                        };
                      }()).then( /*#__PURE__*/function () {
                        var _ref24 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee23(response) {
                          return _regenerator["default"].wrap(function _callee23$(_context23) {
                            while (1) {
                              switch (_context23.prev = _context23.next) {
                                case 0:
                                  _context23.next = 2;
                                  return conn.end();

                                case 2:
                                case "end":
                                  return _context23.stop();
                              }
                            }
                          }, _callee23);
                        }));

                        return function (_x31) {
                          return _ref24.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref25 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee24(err) {
                          return _regenerator["default"].wrap(function _callee24$(_context24) {
                            while (1) {
                              switch (_context24.prev = _context24.next) {
                                case 0:
                                  _context24.next = 2;
                                  return Callback(err);

                                case 2:
                                  _context24.next = 4;
                                  return conn.end();

                                case 4:
                                case "end":
                                  return _context24.stop();
                              }
                            }
                          }, _callee24);
                        }));

                        return function (_x32) {
                          return _ref25.apply(this, arguments);
                        };
                      }());

                    case 2:
                    case "end":
                      return _context25.stop();
                  }
                }
              }, _callee25);
            }));

            return function (_x28) {
              return _ref22.apply(this, arguments);
            };
          }())["catch"]( /*#__PURE__*/function () {
            var _ref26 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee26(error) {
              return _regenerator["default"].wrap(function _callee26$(_context26) {
                while (1) {
                  switch (_context26.prev = _context26.next) {
                    case 0:
                      console.log(error);

                    case 1:
                    case "end":
                      return _context26.stop();
                  }
                }
              }, _callee26);
            }));

            return function (_x33) {
              return _ref26.apply(this, arguments);
            };
          }())["catch"]( /*#__PURE__*/function () {
            var _ref27 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee27(error) {
              return _regenerator["default"].wrap(function _callee27$(_context27) {
                while (1) {
                  switch (_context27.prev = _context27.next) {
                    case 0:
                      console.log(error);

                    case 1:
                    case "end":
                      return _context27.stop();
                  }
                }
              }, _callee27);
            }));

            return function (_x34) {
              return _ref27.apply(this, arguments);
            };
          }());
          break;

        case MariaDB.MARIADB_POOL_CLUSTER:
          /** Module Get Connection For The Library **/
          this.DBInstance.getConnection().then( /*#__PURE__*/function () {
            var _ref28 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee30(conn) {
              return _regenerator["default"].wrap(function _callee30$(_context30) {
                while (1) {
                  switch (_context30.prev = _context30.next) {
                    case 0:
                      _context30.next = 2;
                      return conn.query(SQLString, ArrayParams).then( /*#__PURE__*/function () {
                        var _ref29 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee28(rows, res) {
                          return _regenerator["default"].wrap(function _callee28$(_context28) {
                            while (1) {
                              switch (_context28.prev = _context28.next) {
                                case 0:
                                  _context28.next = 2;
                                  return conn.end();

                                case 2:
                                  _context28.next = 4;
                                  return Callback(null, rows, res);

                                case 4:
                                case "end":
                                  return _context28.stop();
                              }
                            }
                          }, _callee28);
                        }));

                        return function (_x36, _x37) {
                          return _ref29.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref30 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee29(err) {
                          return _regenerator["default"].wrap(function _callee29$(_context29) {
                            while (1) {
                              switch (_context29.prev = _context29.next) {
                                case 0:
                                  _context29.next = 2;
                                  return conn.end();

                                case 2:
                                  _context29.next = 4;
                                  return Callback(err);

                                case 4:
                                case "end":
                                  return _context29.stop();
                              }
                            }
                          }, _callee29);
                        }));

                        return function (_x38) {
                          return _ref30.apply(this, arguments);
                        };
                      }());

                    case 2:
                    case "end":
                      return _context30.stop();
                  }
                }
              }, _callee30);
            }));

            return function (_x35) {
              return _ref28.apply(this, arguments);
            };
          }())["catch"]( /*#__PURE__*/function () {
            var _ref31 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee31(error) {
              return _regenerator["default"].wrap(function _callee31$(_context31) {
                while (1) {
                  switch (_context31.prev = _context31.next) {
                    case 0:
                      console.log(error);

                    case 1:
                    case "end":
                      return _context31.stop();
                  }
                }
              }, _callee31);
            }));

            return function (_x39) {
              return _ref31.apply(this, arguments);
            };
          }());
          break;

        default:
          /** Module Get Connection For The Library **/
          this.DBInstance.getConnection().then( /*#__PURE__*/function () {
            var _ref32 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee34(conn) {
              return _regenerator["default"].wrap(function _callee34$(_context34) {
                while (1) {
                  switch (_context34.prev = _context34.next) {
                    case 0:
                      _context34.next = 2;
                      return conn.query(SQLString, ArrayParams).then( /*#__PURE__*/function () {
                        var _ref33 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee32(rows, res) {
                          return _regenerator["default"].wrap(function _callee32$(_context32) {
                            while (1) {
                              switch (_context32.prev = _context32.next) {
                                case 0:
                                  _context32.next = 2;
                                  return conn.end();

                                case 2:
                                  _context32.next = 4;
                                  return Callback(null, rows, res);

                                case 4:
                                case "end":
                                  return _context32.stop();
                              }
                            }
                          }, _callee32);
                        }));

                        return function (_x41, _x42) {
                          return _ref33.apply(this, arguments);
                        };
                      }())["catch"]( /*#__PURE__*/function () {
                        var _ref34 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee33(err) {
                          return _regenerator["default"].wrap(function _callee33$(_context33) {
                            while (1) {
                              switch (_context33.prev = _context33.next) {
                                case 0:
                                  _context33.next = 2;
                                  return conn.end();

                                case 2:
                                  _context33.next = 4;
                                  return Callback(err);

                                case 4:
                                case "end":
                                  return _context33.stop();
                              }
                            }
                          }, _callee33);
                        }));

                        return function (_x43) {
                          return _ref34.apply(this, arguments);
                        };
                      }());

                    case 2:
                    case "end":
                      return _context34.stop();
                  }
                }
              }, _callee34);
            }));

            return function (_x40) {
              return _ref32.apply(this, arguments);
            };
          }())["catch"]( /*#__PURE__*/function () {
            var _ref35 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee35(error) {
              return _regenerator["default"].wrap(function _callee35$(_context35) {
                while (1) {
                  switch (_context35.prev = _context35.next) {
                    case 0:
                      console.log(error);

                    case 1:
                    case "end":
                      return _context35.stop();
                  }
                }
              }, _callee35);
            }));

            return function (_x44) {
              return _ref35.apply(this, arguments);
            };
          }());
          break;
      }
    }
  }], [{
    key: "MARIADB_CREATECONNECTION",
    get:
    /***
     * @returns {number}
     * @constructor
     */
    function get() {
      return _indexModuleD.Options.MARIADB_CREATECONNECTION;
    }
  }, {
    key: "MARIADB_POOL_CLUSTER",
    get:
    /***
     * @returns {number}
     * @constructor
     */
    function get() {
      return _indexModuleD.Options.MARIADB_POOL_CLUSTER;
    }
  }, {
    key: "MARIADB_POOL",
    get:
    /***
     *
     * @returns {number}
     */
    function get() {
      return _indexModuleD.Options.MARIADB_POOL;
    }
  }, {
    key: "MARIADB_METHOD_CREATE_TABLE",
    get:
    /***
     *
     * @returns {number}
     */
    function get() {
      return 0;
    }
  }, {
    key: "MARIADB_METHOD_CREATE",
    get:
    /***
     *
     * @returns {number}
     */
    function get() {
      return 1;
    }
  }, {
    key: "MARIADB_METHOD_READ",
    get:
    /***
     *
     * @returns {number}
     */
    function get() {
      return 2;
    }
  }, {
    key: "MARIADB_METHOD_UPDATE",
    get:
    /***
     *
     * @returns {number}
     */
    function get() {
      return 3;
    }
  }, {
    key: "MARIADB_METHOD_DELETE",
    get:
    /***
     *
     * @returns {number}
     */
    function get() {
      return 4;
    }
  }, {
    key: "MARIADB_METHOD_RAW",
    get:
    /***
     *
     * @returns {number}
     */
    function get() {
      return 5;
    }
  }]);
  return MariaDB;
}();

var _default = MariaDB;
exports["default"] = _default;
//# sourceMappingURL=index.js.map