import gpio from "gpio";

const Options = {
    /**
     * @type {JSON}
     */
    SERVER_CONFIG : {},


    SERVER_STATE_DEVELOPMENT : "dev",
    SERVER_STATE_PRODUCTION : "prod",

    HTTP2_CORE_ENGINE : 1,
    EXPRESS_CORE_ENGINE : 2,
    FASTIFY_CORE_ENGINE : 3,
    RESTIFY_CORE_ENGINE : 4,
    REACTJS_CORE_ENGINE : 5,

    VIEW_POV_EJS : 1,
    VIEW_POV_MUSTACHE : 2,

    HOST_LOCALHOST : 1,

    FIREWALL_NAT_SRC : "srcnat",
    FIREWALL_NAT_DST : "dstnat",

    MARIADB_TYPE_DATA_BIGINT : "BIGINT",
    MARIADB_TYPE_DATA_LONGTEXT : "LONGTEXT",
    MARIADB_TYPE_DATA_INT : "INT",
    MARIADB_TYPE_DATA_BLOB : "BLOB",

    MARIADB_OPT_AUTO_INCREMENT : "AUTO_INCREMENT",
    MARIADB_OPT_AUTO_PRIMARY_KEY : "PRIMARY KEY",

    MARIADB_CREATECONNECTION : 1,
    MARIADB_POOL_CLUSTER : 2,
    MARIADB_POOL : 3,


    RASPBERRYPI_CORE_CLI : "native",
    RASPBERRY_CORE_GPIO : "gpio",

    GPIO_DIR_OUT : gpio.DIRECTION.OUT,
    GPIO_DIR_IN : gpio.DIRECTION.IN,
    GPIO_DIR_UP : 'up',
    GPIO_DIR_DOWN : 'down',
    GPIO_EVENT_CHANGE : "change",
    GPIO_PULL_UP : 'rising',
    GPIO_PULL_DOWN : 'falling',

    ESCPOS_TYPE_USB : 1,
    ESCPOS_TYPE_NETWORK : 2,
    ESCPOS_TYPE_SERIAL : 3,

    ENCRYPTION_ENGINE_JWT : "JWT",
    ENCRYPTION_ENGINE_CRYPTO : "CRYPTO",

    ALGORITHM_AES_256_GCM : 'aes-256-gcm',
    ALGORITHM_AES_192_GCM : 'aes-192-gcm',
    ALGORITHM_AES_128_GCM : 'aes-128-gcm',

    SICEPAT_EXPEDITION_DEVELOPMENT : 'http://apitrek.sicepat.com/',
    SICEPAT_EXPEDITION_PRODUCTION : 'http://apitrek.sicepat.com/',
    SICEPAT_EXPEDITION_LOCATION_ORIGIN : 'origin',
    SICEPAT_EXPEDITION_LOCATION_DESTINATION : 'destination'
}

export default Options;